diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_stats.c ircd-hybrid-6.0/src/m_stats.c
--- ircd-hybrid-6.0.orig/src/m_stats.c	Fri Jun  8 18:03:38 2001
+++ ircd-hybrid-6.0/src/m_stats.c	Fri Jun  8 17:11:51 2001
@@ -144,12 +144,14 @@
     }
 
 #ifdef SERVERHIDE
-  if (!IsAnOper(sptr))
+  /* We do this on a per-stats basis -- asuffield
+    if (!IsSetOperAuspex(sptr))
     {
-      ignore_request++;
-      valid_stats++;
-      return 0;
+    ignore_request++;
+    valid_stats++;
+    return 0;
     }
+  */
 #endif
 
   if (hunt_server(cptr,sptr,":%s STATS %s :%s",2,parc,parv)!=HUNTED_ISME)
@@ -183,12 +185,12 @@
             continue;
 
           if (IsPerson(acptr) &&
-              !IsAnOper(acptr) && !IsAnOper(sptr) &&
+              !SeesAllConnections(sptr) &&
               (acptr != sptr))
             continue;
           if (IsInvisible(acptr) && (doall || wilds) &&
-              !(MyConnect(sptr) && IsOper(sptr)) &&
-              !IsAnOper(acptr) && (acptr != sptr))
+              !SeesAllConnections(sptr) &&
+              (acptr != sptr))
             continue;
           if (!doall && wilds && !match(name, acptr->name))
             continue;
@@ -207,7 +209,7 @@
           /* if(IsAnOper(sptr)) */
 
           /* Don't trust opers not on this server */
-          if(MyClient(sptr) && IsAnOper(sptr))
+          if(MyClient(sptr) && IsSetOperAuspex(sptr))
             {
               sendto_one(sptr, Lformat, me.name,
                      RPL_STATSLINKINFO, parv[0],
@@ -251,7 +253,7 @@
       break;
     case 'C' : case 'c' :
 #ifdef SERVERHIDE
-      if (!IsAnOper(sptr))
+      if (!IsSetOperAuspex(sptr))
         {
           ignore_request++;
           valid_stats++;
@@ -268,7 +270,7 @@
       break;
 
     case 'D': case 'd':
-      if (!IsAnOper(sptr))
+      if (!CanSeeDlines(sptr))
         {
           sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
           break;
@@ -287,6 +289,11 @@
 
     case 'G': case 'g' :
 #ifdef GLINES
+      if (!CanSeeGlines(sptr))
+        {
+          sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+          break;
+        }
       report_glines(sptr);
       valid_stats++;
 #else
@@ -297,7 +304,7 @@
 
     case 'H' : case 'h' :
 #ifdef SERVERHIDE
-      if (!IsAnOper(sptr))
+      if (!IsSetOperAuspex(sptr))
         {
           ignore_request++;
           valid_stats++;
@@ -311,7 +318,7 @@
 
     case 'I' : case 'i' :
 #ifdef I_LINES_OPER_ONLY
-      if (!IsAnOper(sptr))
+      if (!CanSeeIlines(sptr))
         {
           ignore_request++;
           valid_stats++;
@@ -324,7 +331,7 @@
 
     case 'k' :
 #ifdef K_LINES_OPER_ONLY
-      if (!IsAnOper(sptr)) 
+      if (!CanSeeKlines(sptr)) 
         {
           ignore_request++;
           valid_stats++;
@@ -337,7 +344,7 @@
 
     case 'K' :
 #ifdef K_LINES_OPER_ONLY
-      if (!IsAnOper(sptr))
+      if (!CanSeeKlines(sptr))
         {
           ignore_request++;
           valid_stats++;
@@ -347,7 +354,7 @@
       if(parc > 3)
         report_matching_host_klines(sptr,parv[3]);
       else
-        if (IsAnOper(sptr))
+        if (CanSeeKlines(sptr))
           report_mtrie_conf_links(sptr, CONF_KILL);
         else
           report_matching_host_klines(sptr,sptr->host);
@@ -364,7 +371,7 @@
 
     case 'o' : case 'O' :
 #ifdef O_LINES_OPER_ONLY
-      if (!IsAnOper(sptr))
+      if (!CanSeeOlines(sptr))
         {
           ignore_request++;
           valid_stats++;
@@ -377,7 +384,7 @@
 
     case 'P' :
 #ifdef P_LINES_OPER_ONLY
-      if (!IsAnOper(sptr)) 
+      if (!IsSetOperAuspex(sptr)) 
         {
           ignore_request++;
           valid_stats++;
@@ -394,7 +401,7 @@
       break;
 
     case 'Q' : case 'q' :
-      if(!IsAnOper(sptr))
+      if(!CanSeeQlines(sptr))
         sendto_one(sptr,":%s NOTICE %s :This server does not support Q lines",
                    me.name, parv[0]);
       else
@@ -410,7 +417,7 @@
       break;
 
     case 'S' : case 's':
-      if (IsAnOper(sptr))
+      if (IsDebugger(sptr))
         list_scache(cptr,sptr,parc,parv);
       else
         sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
@@ -418,7 +425,7 @@
       break;
 
     case 'T' : case 't' :
-      if (!IsAnOper(sptr))
+      if (!CanSeeStatsT(sptr))
         {
           sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
           break;
@@ -452,7 +459,7 @@
       break;
 
     case 'x' : case 'X' :
-      if(IsAnOper(sptr))
+      if(CanSeeXlines(sptr))
         {
           report_specials(sptr,CONF_XLINE,RPL_STATSXLINE);
           valid_stats++;
@@ -460,7 +467,7 @@
       break;;
 
     case 'Y' : case 'y' :
-      if(IsAnOper(sptr))
+      if(CanSeeYlines(sptr))
         { 
           report_classes(sptr);
           valid_stats++;
@@ -468,7 +475,7 @@
       break;
 
     case 'Z' : case 'z' :
-      if (IsAnOper(sptr))
+      if (IsDebugger(sptr))
         {
           count_memory(sptr, parv[0]);
         }
@@ -478,7 +485,7 @@
       break;
 
     case '?':
-      if (IsAnOper(sptr))
+      if (CanSeeStatsServinfo(sptr))
       {
         serv_info(sptr, parv[0]);
       }
@@ -505,28 +512,28 @@
     {
       if ( (stat == 'L') || (stat == 'l') )
         {
-          sendto_realops_flags(FLAGS_SPY,
-                "STATS %c requested by %s (%s@%s) [%s] on %s%s",
-                stat,
-                sptr->name,
-                sptr->username,
-                sptr->host,
-                sptr->user->server,
-                parc > 2 ? parv[2] : "<no recipient>",
-                ignore_request > 0 ? " [request ignored]" : "\0"
-                );
+          sendto_realops_flag(UMODE_SPY,
+			      "STATS %c requested by %s (%s@%s) [%s] on %s%s",
+			      stat,
+			      sptr->name,
+			      sptr->username,
+			      sptr->host,
+			      sptr->user->server,
+			      parc > 2 ? parv[2] : "<no recipient>",
+			      ignore_request > 0 ? " [request ignored]" : "\0"
+			      );
         }
       else
         {
-          sendto_realops_flags(FLAGS_SPY,
-                "STATS %c requested by %s (%s@%s) [%s]%s",
-                stat,
-                sptr->name,
-                sptr->username,
-                sptr->host,
-                sptr->user->server,
-                ignore_request > 0 ? " [request ignored]" : "\0"
-                );
+          sendto_realops_flag(UMODE_SPY,
+			      "STATS %c requested by %s (%s@%s) [%s]%s",
+			      stat,
+			      sptr->name,
+			      sptr->username,
+			      sptr->host,
+			      sptr->user->server,
+			      ignore_request > 0 ? " [request ignored]" : "\0"
+			      );
         }
     }
 #endif
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_stopic.c ircd-hybrid-6.0/src/m_stopic.c
--- ircd-hybrid-6.0.orig/src/m_stopic.c	Fri Jun  8 18:03:38 2001
+++ ircd-hybrid-6.0/src/m_stopic.c	Wed Jun  6 11:34:31 2001
@@ -119,7 +119,7 @@
                  me.name, parv[0], "STOPIC");
       return 0;
     }
-  if (!IsPrivileged(sptr))
+  if (!IsServer(sptr))
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return(0);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_trace.c ircd-hybrid-6.0/src/m_trace.c
--- ircd-hybrid-6.0.orig/src/m_trace.c	Tue Nov 21 06:49:30 2000
+++ ircd-hybrid-6.0/src/m_trace.c	Fri Jun  8 12:23:44 2001
@@ -115,7 +115,7 @@
   static time_t now;
 
 #ifdef SERVERHIDE
-  if (!IsAnOper(sptr))
+  if (!IsSetOperAuspex(sptr))
     return 0;
 #endif
 
@@ -152,7 +152,7 @@
       return 0;
     }
 
-  if(!IsAnOper(sptr))
+  if(!NoFloodProtection(sptr))
     {
       /* pacing for /trace is problemmatical */
 #if PACE_TRACE
@@ -168,9 +168,11 @@
           last_used = CurrentTime;
         }
 #endif
-
+    }
+  if (!IsSetOperAuspex(sptr))
+    {
       if (parv[1] && !strchr(parv[1],'.') && (strchr(parv[1], '*')
-          || strchr(parv[1], '?'))) /* bzzzt, no wildcard nicks for nonopers */
+          || strchr(parv[1], '?'))) /* bzzzt, no wildcard nicks for non(auspex)opers */
         {
           sendto_one(sptr, form_str(RPL_ENDOFTRACE),me.name,
                      parv[0], parv[1]);
@@ -179,17 +181,17 @@
     }
 
   if(MyClient(sptr))
-    sendto_realops_flags(FLAGS_SPY, "trace requested by %s (%s@%s) [%s]",
-                       sptr->name, sptr->username, sptr->host,
-                       sptr->user->server);
+    sendto_realops_flag(UMODE_SPY, "trace requested by %s (%s@%s) [%s]",
+			sptr->name, sptr->username, sptr->host,
+			sptr->user->server);
 
 
   doall = (parv[1] && (parc > 1)) ? match(tname, me.name): TRUE;
   wilds = !parv[1] || strchr(tname, '*') || strchr(tname, '?');
   dow = wilds || doall;
   
-  if(!IsAnOper(sptr) || !dow) /* non-oper traces must be full nicks */
-                              /* lets also do this for opers tracing nicks */
+  if(!IsSetOperAuspex(sptr) || !dow) /* non-oper traces must be full nicks */
+                                     /* lets also do this for opers tracing nicks */
     {
       const char* name;
       const char* ip;
@@ -209,7 +211,7 @@
 
       c_class = get_client_class(acptr);
 
-      if (IsAnOper(acptr))
+      if (SeesOpers(sptr) && IsAnOper(acptr))
         {
           sendto_one(sptr, form_str(RPL_TRACEOPERATOR),
                      me.name, parv[0], c_class,
@@ -217,7 +219,7 @@
 #ifdef SERVERHIDE
                      "255.255.255.255",
 #else
-                     IsAnOper(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
+                     SeesAllConnections(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
 #endif
                      now - acptr->lasttime,
                      (acptr->user)?(now - acptr->user->last):0);
@@ -230,7 +232,7 @@
 #ifdef SERVERHIDE
                      "255.255.255.255",
 #else
-                     IsAnOper(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
+                     SeesAllConnections(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
 #endif
                      now - acptr->lasttime,
                      (acptr->user)?(now - acptr->user->last):0);
@@ -240,7 +242,7 @@
       return 0;
     }
 
-  if (dow && LIFESUX && !IsOper(sptr))
+  if (dow && LIFESUX && !SendWhileLifeSucks(sptr))
     {
       sendto_one(sptr,form_str(RPL_LOAD2HI),me.name,parv[0]);
       return 0;
@@ -263,7 +265,7 @@
         }
 #else
       if (IsPerson(acptr) &&
-        (!IsInvisible(acptr) || IsAnOper(sptr)))
+        (!IsInvisible(acptr) || SeesAllConnections(sptr)))
         {
           link_u[acptr->from->fd]++;
         }
@@ -287,8 +289,8 @@
       if (!(acptr = local[i])) /* Local Connection? */
         continue;
       if (IsInvisible(acptr) && dow &&
-          !(MyConnect(sptr) && IsAnOper(sptr)) &&
-          !IsAnOper(acptr) && (acptr != sptr))
+          !SeesAllConnections(sptr) &&
+          (acptr != sptr))
         continue;
       if (!doall && wilds && !match(tname, acptr->name))
         continue;
@@ -323,10 +325,12 @@
         case STAT_CLIENT:
           /* Only opers see users if there is a wildcard
            * but anyone can see all the opers.
+	   *
+	   * Or at least, those who SeesOpers() -- asuffield
            */
-          if ((IsAnOper(sptr) &&
+          if ((IsSetOperAuspex(sptr) &&
               (MyClient(sptr) || !(dow && IsInvisible(acptr))))
-              || !dow || IsAnOper(acptr))
+              || !dow || (IsAnOper(acptr) && SeesOpers(sptr)))
             {
               if (IsAnOper(acptr))
                 sendto_one(sptr,
@@ -337,7 +341,7 @@
 #ifdef SERVERHIDE
                            "255.255.255.255",
 #else
-                           IsAnOper(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
+                           IsSetOperAuspex(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
 #endif
                            now - acptr->lasttime,
                            (acptr->user)?(now - acptr->user->last):0);
@@ -348,7 +352,7 @@
 #ifdef SERVERHIDE
                            "255.255.255.255",
 #else
-                           IsAnOper(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
+                           IsSetOperAuspex(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
 #endif
                            now - acptr->lasttime,
                            (acptr->user)?(now - acptr->user->last):0);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_unkline.c ircd-hybrid-6.0/src/m_unkline.c
--- ircd-hybrid-6.0.orig/src/m_unkline.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/m_unkline.c	Wed Jun  6 11:35:32 2001
@@ -87,16 +87,13 @@
       return -1;
     }
 
-  if (!IsPrivileged(sptr))  
+  if (!(IsServer(sptr) || IsSetOperUnkline(sptr)))  
     {
-      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, 
-                 parv[0]);
-      return 0;
-    }
-
-  if (!IsServer(cptr) && !IsSetOperUnkline(sptr))
-    {
-      sendto_one(sptr,":%s NOTICE %s :You have no U flag",me.name,parv[0]);
+      if (SeesOperMessages(sptr))
+	sendto_one(sptr,":%s NOTICE %s :You have no U umode",me.name,parv[0]);
+      else
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, 
+		   parv[0]);
       return 0;
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_userhost.c ircd-hybrid-6.0/src/m_userhost.c
--- ircd-hybrid-6.0.orig/src/m_userhost.c	Tue Jan  2 05:48:18 2001
+++ ircd-hybrid-6.0/src/m_userhost.c	Wed Jun  6 00:24:09 2001
@@ -133,14 +133,14 @@
           if (acptr == sptr) /* show real IP for USERHOST on yourself */
             rl = ircsprintf(response, "%s%s=%c%s@%s ",
 		       acptr->name,
-		       IsAnOper(acptr) ? "*" : "",
+		       IsAnOper(acptr) && SeesOpers(sptr) ? "*" : "",
 		       (acptr->user->away) ? '-' : '+',
 		       acptr->username,
 		       acptr->sockhost);
           else
             rl = ircsprintf(response, "%s%s=%c%s@%s ",
 		       acptr->name,
-		       IsAnOper(acptr) ? "*" : "",
+		       IsAnOper(acptr) && SeesOpers(sptr) ? "*" : "",
 		       (acptr->user->away) ? '-' : '+',
 		       acptr->username,
 		       acptr->host);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_version.c ircd-hybrid-6.0/src/m_version.c
--- ircd-hybrid-6.0.orig/src/m_version.c	Sat Jul 31 05:48:04 1999
+++ ircd-hybrid-6.0/src/m_version.c	Wed Jun  6 00:41:10 2001
@@ -93,7 +93,7 @@
  */
 int m_version(struct Client* cptr, struct Client* sptr, int parc, char* parv[])
 {
-  if (IsAnOper(sptr))
+  if (IsSetOperRemote(sptr))
      {
        if (hunt_server(cptr, sptr, ":%s VERSION :%s", 
                        1, parc, parv) == HUNTED_ISME)
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_wallops.c ircd-hybrid-6.0/src/m_wallops.c
--- ircd-hybrid-6.0.orig/src/m_wallops.c	Fri Jun  8 18:03:38 2001
+++ ircd-hybrid-6.0/src/m_wallops.c	Wed Jun  6 17:27:04 2001
@@ -98,11 +98,11 @@
 int m_wallops(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
 { 
   char* message;
-  int flags=0;
+  int flag=0;
 
   if (parc == 3)
     {
-      flags = atoi(parv[1]);
+      flag = atoi(parv[1]);
       message = parv[2];
     }
   else
@@ -115,7 +115,7 @@
       return 0;
     }
 
-  if (!IsServer(sptr) && MyConnect(sptr) && !IsAnOper(sptr))
+  if (!IsServer(sptr) && MyConnect(sptr) && !SendWallops(sptr))
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return(0);
@@ -129,7 +129,7 @@
 
   if (parc == 3)
     {
-      sendto_ops_flags_butone(cptr, flags, "%s", message);
+      sendto_ops_flag_butone(cptr, flag, "%s", message);
       return 0;
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_who.c ircd-hybrid-6.0/src/m_who.c
--- ircd-hybrid-6.0.orig/src/m_who.c	Fri Jun  8 18:03:38 2001
+++ ircd-hybrid-6.0/src/m_who.c	Wed Jun  6 01:10:57 2001
@@ -107,7 +107,7 @@
     *p++ = 'H';
   if (IsAnOper(acptr) 
 #ifdef OPERHIDE
-      && IsAnOper(sptr)
+      && SeesOpers(sptr)
 #endif
      )
     *p++ = '*';
@@ -131,7 +131,7 @@
              acptr->username,
              acptr->host,
 #ifdef SERVERHIDE
-             IsAnOper(sptr) ? acptr->user->server : NETWORK_NAME,
+             IsSetOperAuspex(sptr) ? acptr->user->server : NETWORK_NAME,
 #else
              acptr->user->server,
 #endif
@@ -210,24 +210,27 @@
       /*
        * List all users on a given channel
        */
-      chptr = hash_find_channel(channame, NULL);
-      if (chptr)
-        {
-          member = IsMember(sptr, chptr) || SeesAllConnections(sptr);
-          if (member || !SecretChannel(chptr))
-            for (lp = chptr->members; lp; lp = lp->next)
-              {
-                if (oper && !IsAnOper(lp->value.cptr))
-                  continue;
-                if (IsInvisible(lp->value.cptr) && !member)
-                  continue;
-                do_who(sptr, lp->value.cptr, chptr, lp);
-              }
-        }
+      if (!oper || SeesOpers(sptr)) /* If you're doing an oper search, you need SeesOpers() */
+	{
+	  chptr = hash_find_channel(channame, NULL);
+	  if (chptr)
+	    {
+	      member = IsMember(sptr, chptr) || SeesAllConnections(sptr);
+	      if (member || !SecretChannel(chptr))
+		for (lp = chptr->members; lp; lp = lp->next)
+		  {
+		    if (oper && !IsAnOper(lp->value.cptr))
+		      continue;
+		    if (IsInvisible(lp->value.cptr) && !member)
+		      continue;
+		    do_who(sptr, lp->value.cptr, chptr, lp);
+		  }
+	    }
+	}
     }
   else if (mask && 
            ((acptr = find_client(mask, NULL)) != NULL) &&
-           IsPerson(acptr) && (!oper || IsAnOper(acptr)))
+           IsPerson(acptr) && (!oper || (IsAnOper(acptr) && SeesOpers(sptr))))
     {
       int isinvis = 0;
       struct Channel *ch2ptr = NULL;
@@ -247,7 +250,8 @@
         }
       do_who(sptr, acptr, ch2ptr, NULL);
     }
-  else for (acptr = GlobalClientList; acptr; acptr = acptr->next)
+  else if (!oper || SeesOpers(sptr))
+    for (acptr = GlobalClientList; acptr; acptr = acptr->next)
     {
       struct Channel *ch2ptr = NULL;
       int       showperson, isinvis;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_whois.c ircd-hybrid-6.0/src/m_whois.c
--- ircd-hybrid-6.0.orig/src/m_whois.c	Fri Jun  8 18:03:39 2001
+++ ircd-hybrid-6.0/src/m_whois.c	Wed Jun  6 10:49:18 2001
@@ -144,7 +144,7 @@
       parv[1] = parv[2];
     }
 
-  if(!IsAnOper(sptr) && !MyConnect(sptr)) /* pace non local requests */
+  if(!NoFloodProtection(sptr) && !MyConnect(sptr)) /* pace non local requests */
     {
       if((last_used + WHOIS_WAIT) > CurrentTime)
         {
@@ -271,7 +271,7 @@
                        me.name, parv[0], name, buf);
          
 #ifdef SERVERHIDE
-          if (!(IsAnOper(sptr) || acptr == sptr))
+          if (!(IsSetOperAuspex(sptr) || acptr == sptr))
             sendto_one(sptr, form_str(RPL_WHOISSERVER),
                        me.name, parv[0], name, NETWORK_NAME,
                        NETWORK_DESC);
@@ -287,7 +287,7 @@
 
           if (IsAnOper(acptr)
 #ifdef OPERHIDE
-               && IsAnOper(sptr)
+               && SeesOpers(sptr)
 #endif
               )
             sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
@@ -309,7 +309,7 @@
 
           if ((acptr->user
 #ifdef SERVERHIDE
-              && IsAnOper(sptr)
+              && IsSetOperAuspex(sptr)
 #endif
               && MyConnect(acptr)))
             sendto_one(sptr, form_str(RPL_WHOISIDLE),
@@ -426,7 +426,7 @@
                        me.name, parv[0], name, buf);
          
 #ifdef SERVERHIDE
-          if (!(IsAnOper(sptr) || acptr == sptr))
+          if (!(IsSetOperAuspex(sptr) || acptr == sptr))
             sendto_one(sptr, form_str(RPL_WHOISSERVER),
                        me.name, parv[0], name, NETWORK_NAME,
                        NETWORK_DESC);
@@ -442,7 +442,7 @@
 
           if (IsAnOper(acptr)
 #ifdef OPERHIDE
-               && IsAnOper(sptr)
+               && SeesOpers(sptr)
 #endif
               )
             sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
@@ -458,7 +458,7 @@
 
           if ((acptr->user
 #ifdef SERVERHIDE
-              && IsAnOper(sptr) 
+              && IsSetOperAuspex(sptr) 
 #endif                 
               && MyConnect(acptr)))
             sendto_one(sptr, form_str(RPL_WHOISIDLE),
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/motd.c ircd-hybrid-6.0/src/motd.c
--- ircd-hybrid-6.0.orig/src/motd.c	Fri Jun  8 18:03:36 2001
+++ ircd-hybrid-6.0/src/motd.c	Wed Jun  6 18:35:27 2001
@@ -51,7 +51,7 @@
 {
   static time_t last_used = 0;
 
-  if(!IsAnOper(sptr))
+  if(!NoFloodProtection(sptr))
     {
       if((last_used + PACE_WAIT) > CurrentTime)
         {
@@ -67,9 +67,9 @@
   if (hunt_server(cptr, sptr, ":%s MOTD :%s", 1,parc,parv)!=HUNTED_ISME)
     return 0;
 
-  sendto_realops_flags(FLAGS_SPY, "motd requested by %s (%s@%s) [%s]",
-                     sptr->name, sptr->username, sptr->host,
-                     sptr->user->server);
+  sendto_realops_flag(UMODE_SPY, "motd requested by %s (%s@%s) [%s]",
+		      sptr->name, sptr->username, sptr->host,
+		      sptr->user->server);
 
   return(SendMessageFile(sptr,&ConfigFileEntry.motd));
 }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/mtrie_conf.c ircd-hybrid-6.0/src/mtrie_conf.c
--- ircd-hybrid-6.0.orig/src/mtrie_conf.c	Fri Dec  1 06:28:49 2000
+++ ircd-hybrid-6.0/src/mtrie_conf.c	Wed Jun  6 10:56:58 2001
@@ -1235,7 +1235,7 @@
       if(match(host,need_host))
         {
           p = (char *)NULL;
-          if(!IsAnOper(sptr))
+          if(!CanSeeKlines(sptr))
             {
               p = strchr(pass,'|');
               if(p)
@@ -1279,7 +1279,7 @@
           /* Non local opers do not need to know about
            * I lines that do spoofing 
            */
-          if(!(MyConnect(sptr) && IsAnOper(sptr)) &&
+          if(!(MyConnect(sptr) && IsSetOperAuspex(sptr)) &&
              IsConfDoSpoofIp(found_conf))
             continue;
 
@@ -1354,7 +1354,7 @@
 
           /* Hide any comment following a '|' seen in the password field */
           p = (char *)NULL;
-          if(!IsAnOper(sptr))
+          if(!CanSeeKlines(sptr))
             {
               p = strchr(pass,'|');
               if(p)
@@ -1402,32 +1402,32 @@
     *prefix_ptr++ = '=';
 
 #ifdef E_LINES_OPER_ONLY
-  if(IsAnOper(sptr))
+  if(CanSeeElines(sptr))
 #endif
     if (IsConfExemptGline(aconf))
       *prefix_ptr++ = '_';
 
 #ifdef E_LINES_OPER_ONLY
-  if(IsAnOper(sptr))
+  if(CanSeeElines(sptr))
 #endif
     if (IsConfElined(aconf))
       *prefix_ptr++ = '^';
 
 #ifdef B_LINES_OPER_ONLY
-  if(IsAnOper(sptr))
+  if(CanSeeBlines(sptr))
 #endif
     if (IsConfBlined(aconf))
       *prefix_ptr++ = '&';
 
 #ifdef F_LINES_OPER_ONLY
-  if(IsAnOper(sptr))
+  if(CanSeeFlines(sptr))
 #endif
     if (IsConfFlined(aconf))
       *prefix_ptr++ = '>';
 
 #ifdef IDLE_CHECK  
 #ifdef E_LINES_OPER_ONLY
-  if(IsAnOper(sptr))
+  if(CanSeeElines(sptr))
 #endif
     if (IsConfIdlelined(aconf))
       *prefix_ptr++ = '<';
@@ -1479,7 +1479,7 @@
                        * password field
                        */
                       p = (char *)NULL;
-                      if(!IsAnOper(sptr))
+                      if(!CanSeeKlines(sptr))
                         {
                           p = strchr(pass,'|');
                           if(p)
@@ -1500,7 +1500,7 @@
                       /* Non local opers do not need to know about
                        * I lines that do spoofing
                        */
-                      if(!(MyConnect(sptr) && IsAnOper(sptr))
+                      if(!(MyConnect(sptr) && IsSetOperAuspex(sptr))
                          && IsConfDoSpoofIp(aconf))
                         continue;
 
@@ -1534,7 +1534,7 @@
                   if (aconf->status == CONF_KILL)
                     {
                       p = (char *)NULL;
-                      if(!IsAnOper(sptr))
+                      if(!CanSeeKlines(sptr))
                         {
                           p = strchr(pass,'|');
                           if(p)
@@ -1555,7 +1555,7 @@
                       /* Non local opers do not need to know about
                        * I lines that do spoofing
                        */
-                      if(!(MyConnect(sptr) && IsAnOper(sptr))
+                      if(!(MyConnect(sptr) && IsSetOperAuspex(sptr))
                          && IsConfDoSpoofIp(aconf))
                         continue;
                       c = 'I';
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/parse.c ircd-hybrid-6.0/src/parse.c
--- ircd-hybrid-6.0.orig/src/parse.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/parse.c	Wed Jun  6 18:40:21 2001
@@ -235,7 +235,7 @@
       if ((mptr->flags & 1) && !(IsServer(cptr)))
         {
 #ifdef NO_OPER_FLOOD
-          if (IsAnOper(cptr))
+          if (NoFloodProtection(cptr))
             /* "randomly" (weighted) increase the since */
             cptr->since += (cptr->receiveM % 5) ? 1 : 0;
           else
@@ -520,22 +520,22 @@
    */
   if (IsServer(sptr) || IsMe(sptr))
     {
-      sendto_realops_flags(FLAGS_DEBUG, "Message for %s[%s] from %s",
-                         sptr->name, sptr->from->name,
-                         get_client_name(cptr, TRUE));
+      sendto_realops_flag(UMODE_SERVNOTICE, "Message for %s[%s] from %s",
+			  sptr->name, sptr->from->name,
+			  get_client_name(cptr, TRUE));
       if (IsServer(cptr))
         {
-          sendto_realops_flags(FLAGS_DEBUG,
-                             "Not dropping server %s (%s) for Fake Direction",
-                             cptr->name, sptr->name);
+          sendto_realops_flag(UMODE_SERVNOTICE,
+			      "Not dropping server %s (%s) for Fake Direction",
+			      cptr->name, sptr->name);
           return -1;
         }
 
       if (IsClient(cptr))
-        sendto_realops_flags(FLAGS_DEBUG,
-                           "Would have dropped client %s (%s@%s) [%s from %s]",
-                           cptr->name, cptr->username, cptr->host,
-                           cptr->user->server, cptr->from->name);
+        sendto_realops_flag(UMODE_SERVNOTICE,
+			    "Would have dropped client %s (%s@%s) [%s from %s]",
+			    cptr->name, cptr->username, cptr->host,
+			    cptr->user->server, cptr->from->name);
       return -1;
 
       /*
@@ -556,20 +556,20 @@
     if (DoesTS(cptr))
       {
         if (sptr->user)
-          sendto_realops_flags(FLAGS_DEBUG,
-              "Message for %s[%s@%s!%s] from %s (TS, ignored)",
-                             sptr->name, sptr->username, sptr->host,
-                           sptr->from->name, get_client_name(cptr, TRUE));
+          sendto_realops_flag(UMODE_DEBUG,
+			      "Message for %s[%s@%s!%s] from %s (TS, ignored)",
+			      sptr->name, sptr->username, sptr->host,
+			      sptr->from->name, get_client_name(cptr, TRUE));
         return 0;
       }
     else
       {
         if (sptr->user)
           {
-            sendto_realops_flags(FLAGS_DEBUG,
-                             "Message for %s[%s@%s!%s] from %s",
-                           sptr->name, sptr->username, sptr->host,
-                           sptr->from->name, get_client_name(cptr, TRUE));
+            sendto_realops_flag(UMODE_DEBUG,
+				"Message for %s[%s@%s!%s] from %s",
+				sptr->name, sptr->username, sptr->host,
+				sptr->from->name, get_client_name(cptr, TRUE));
           }
         sendto_serv_butone(NULL,
                            ":%s KILL %s :%s (%s[%s] != %s, Fake Prefix)",
@@ -592,10 +592,10 @@
 
   if (IsClient(cptr))
     {
-      sendto_realops_flags(FLAGS_DEBUG,
-                 "Weirdness: Unknown client prefix (%s) from %s, Ignoring %s",
-                         buffer,
-                         get_client_name(cptr, FALSE), sender);
+      sendto_realops_flag(UMODE_DEBUG,
+			  "Weirdness: Unknown client prefix (%s) from %s, Ignoring %s",
+			  buffer,
+			  get_client_name(cptr, FALSE), sender);
       return;
     }
 
@@ -615,8 +615,8 @@
                get_client_name(cptr, FALSE));
   else
     {
-      sendto_realops_flags(FLAGS_DEBUG,
-        "Unknown prefix (%s) from %s, Squitting %s", buffer, get_client_name(cptr, FALSE), sender);
+      sendto_realops_flag(UMODE_DEBUG,
+			  "Unknown prefix (%s) from %s, Squitting %s", buffer, get_client_name(cptr, FALSE), sender);
       sendto_one(cptr, ":%s SQUIT %s :(Unknown prefix (%s) from %s)",
                  me.name, sender, buffer, get_client_name(cptr, FALSE));
     }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/res.c ircd-hybrid-6.0/src/res.c
--- ircd-hybrid-6.0.orig/src/res.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/res.c	Wed Jun  6 10:58:51 2001
@@ -1684,8 +1684,14 @@
   int     i;
   struct hostent* hp;
 
-  if (!IsAnOper(sptr))
-    return 0;
+  if (!IsSetOperAuspex(sptr))
+    {
+      if (!SeesOperMessages(sptr))
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      else
+	sendto_one(sptr,":%s NOTICE %s :You have no a umode",me.name,parv[0]);
+      return 0;
+    }
 
   if (parv[1] && *parv[1] == 'l') {
     for(cp = cacheTop; cp; cp = cp->list_next) {
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_bsd.c ircd-hybrid-6.0/src/s_bsd.c
--- ircd-hybrid-6.0.orig/src/s_bsd.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/s_bsd.c	Wed Jun  6 18:36:40 2001
@@ -170,7 +170,7 @@
 {
   who = (who) ? who : "";
 
-  sendto_realops_flags(FLAGS_DEBUG, text, who, strerror(error));
+  sendto_realops_flag(UMODE_DEBUG, text, who, strerror(error));
 
   log(L_ERROR, text, who, strerror(error));
 }
@@ -887,7 +887,7 @@
     
     if (IsPerson(cptr) &&
 #ifdef NO_OPER_FLOOD
-        !IsAnOper(cptr) &&
+        !NoFloodProtection(cptr) &&
 #endif
         DBufLength(&cptr->recvQ) > CLIENT_FLOOD) {
       return exit_client(cptr, cptr, cptr, "Excess Flood");
